loop(1)

NAME
loop - control plane for your loopd

SYNOPSIS
loop
    [--help|-h]
    [--loopdir]=[value]
    [--macaroonpath]=[value]
    [--network|-n]=[value]
    [--rpcserver]=[value]
    [--tlscertpath]=[value]
    [--version|-v]

Usage:
    loop [GLOBAL OPTIONS] [command [COMMAND OPTIONS]] [ARGUMENTS...]

GLOBAL OPTIONS
--help, -h: show help

--loopdir="": path to loop's base directory (default: ~/.loop)

--macaroonpath="": path to macaroon file (default: ~/.loop/mainnet/loop.macaroon)

--network, -n="": the network loop is running on e.g. mainnet, testnet, etc. (default: mainnet)

--rpcserver="": loopd daemon address host:port (default: localhost:11010)

--tlscertpath="": path to loop's TLS certificate (default: ~/.loop/mainnet/tls.cert)

--version, -v: print the version

COMMANDS

out
perform an off-chain to on-chain swap (looping out)

--account="": the name of the account to generate a new address from. You can list the names of valid accounts in your backing lnd instance with "lncli wallet accounts list"

--account_addr_type="": the address type of the extended public key specified in account. Currently only pay-to-taproot-pubkey(p2tr) is supported (default: p2tr)

--addr="": the optional address that the looped out funds should be sent to, if let blank the funds will go to lnd's wallet

--amt="": the amount in satoshis to loop out. To check for the minimum and maximum amounts to loop out please consult "loop terms" (default: 0)

--asset_edge_node="": the pubkey of the edge node of the asset to loop out, this is required if the taproot assets daemon has multiple channels of the given asset id with different edge nodes

--asset_id="": the asset ID of the asset to loop out, if this is set, the loop daemon will require a connection to a taproot assets daemon

--channel="": the comma-separated list of short channel IDs of the channels to loop out

--conf_target="": the number of blocks from the swap initiation height that the on-chain HTLC should be swept within (default: 9)

--fast: indicate you want to swap immediately, paying potentially a higher fee. If not set the swap server might choose to wait up to 30 minutes before publishing the swap HTLC on-chain, to save on its chain fees. Not setting this flag therefore might result in a lower swap fee

--force: Assumes yes during confirmation. Using this option will result in an immediate swap

--help, -h: show help

--htlc_confs="": the number of confirmations (in blocks) that we require for the htlc extended by the server before we reveal the preimage (default: 1)

--label="": an optional label for this swap,limited to 500 characters. The label may not start with our reserved prefix: [reserved].

--max_swap_routing_fee="": the max off-chain swap routing fee in satoshis, if not specified, a default max fee will be used (default: 0)

--payment_timeout="": the timeout for each individual off-chain payment attempt. If not set, the default timeout of 1 hour will be used. As the payment might be retried, the actual total time may be longer (default: 0s)

--verbose, -v: show expanded details

in
perform an on-chain to off-chain swap (loop in)

--amt="": the amount in satoshis to loop in. To check for the minimum and maximum amounts to loop in please consult "loop terms" (default: 0)

--conf_target="": the target number of blocks the on-chain htlc broadcast by the swap client should confirm within (default: 0)

--external: expect htlc to be published externally

--force: Assumes yes during confirmation. Using this option will result in an immediate swap

--help, -h: show help

--label="": an optional label for this swap,limited to 500 characters. The label may not start with our reserved prefix: [reserved].

--last_hop="": the pubkey of the last hop to use for this swap

--private: generates and passes routehints. Should be used if the connected node is only reachable via private channels

--route_hints="": route hints that can each be individually used to assist in reaching the invoice's destination (default: [])

--verbose, -v: show expanded details

terms
Display the current swap terms imposed by the server.

--help, -h: show help

monitor
monitor progress of any active swaps

--help, -h: show help

quote
get a quote for the cost of a swap

--help, -h: show help

  in
get a quote for the cost of a loop in swap

--conf_target="": the target number of blocks the on-chain htlc broadcast by the swap client should confirm within (default: 0)

--deposit_outpoint="": one or more static address deposit outpoints to quote for. Deposit outpoints are not to be used in combination with an amount. Eachadditional outpoint can be added by specifying --deposit_outpoint tx_id:idx (default: [])

--help, -h: show help

--last_hop="": the pubkey of the last hop to use for the quote

--private: generates and passes routehints. Should be used if the connected node is only reachable via private channels

--route_hints="": route hints that can each be individually used to assist in reaching the invoice's destination (default: [])

--verbose, -v: show expanded details

  out
get a quote for the cost of a loop out swap

--conf_target="": the number of blocks from the swap initiation height that the on-chain HTLC should be swept within in a Loop Out (default: 9)

--fast: Indicate you want to swap immediately, paying potentially a higher fee. If not set the swap server might choose to wait up to 30 minutes before publishing the swap HTLC on-chain, to save on chain fees. Not setting this flag might result in a lower swap fee.

--help, -h: show help

--verbose, -v: show expanded details

listauth
list all L402 tokens

--help, -h: show help

fetchl402
fetches a new L402 authentication token from the server

--help, -h: show help

listswaps
list traditional Loop In and Loop Out swaps

--channel="": the comma-separated list of short channel IDs of the channels to loop out

--help, -h: show help

--label="": an optional label for this swap,limited to 500 characters. The label may not start with our reserved prefix: [reserved].

--last_hop="": the pubkey of the last hop to use for this swap

--loop_in_only: only list swaps that are loop in swaps

--loop_out_only: only list swaps that are loop out swaps

--max_swaps="": Max number of swaps to return after filtering (default: 0)

--pending_only: only list pending swaps

--start_time_ns="": Unix timestamp in nanoseconds to select swaps initiated after this time (default: 0)

swapinfo
show the status of a traditional swap

--help, -h: show help

--id="": the ID of the swap (default: 0)

getparams
show liquidity manager parameters

--help, -h: show help

setrule
set liquidity manager rule for a channel/peer

--clear: remove the rule currently set for the channel/peer.

--help, -h: show help

--incoming_threshold="": the minimum percentage of incoming liquidity to total capacity beneath which to recommend loop out to acquire incoming. (default: 0)

--outgoing_threshold="": the minimum percentage of outbound liquidity that we do not want to drop below. (default: 0)

--type="": the type of swap to perform, set to 'out' for acquiring inbound liquidity or 'in' for acquiring outbound liquidity. (default: out)

suggestswaps
show a list of suggested swaps

--help, -h: show help

setparams
update the parameters set for the liquidity manager

--account="": the name of the account to generate a new address from. You can list the names of valid accounts in your backing lnd instance with "lncli wallet accounts list".

--account_addr_type="": the address type of the extended public key specified in account. Currently only pay-to-taproot-pubkey(p2tr) is supported (default: p2tr)

--asset_easyautoloop: set to true to enable asset easy autoloop, which will automatically dispatch asset swaps in order to meet the target local balance.

--asset_id="": If set to a valid asset ID, the easyautoloop and localbalancesat flags will be set for the specified asset.

--asset_localbalance="": the target size of total local balance in asset units, used by asset easy autoloop. (default: 0)

--autobudget="": the maximum amount of fees in satoshis that automatically dispatched loop out swaps may spend. (default: 0)

--autobudgetrefreshperiod="": the time period over which the automated loop budget is refreshed. (default: 0s)

--autoinflight="": the maximum number of automatically dispatched swaps that we allow to be in flight. (default: 0)

--autoloop: set to true to enable automated dispatch of swaps, limited to the budget set by autobudget.

--destaddr="": custom address to be used as destination for autoloop loop out, set to "default" in order to revert to default behavior.

--easyatutoloop_includeallpeers: include all peers back into easy autoloop by clearing the exclusion list. It cannot be combined with --easyautoloop_excludepeer

--easyautoloop: set to true to enable easy autoloop, which will automatically dispatch swaps in order to meet the target local balance.

--easyautoloop_excludepeer="": list of peer pubkeys (hex) to exclude from easy autoloop channel selection; repeat --easyautoloop_excludepeer for multiple peers (default: [])

--failurebackoff="": the amount of time, in seconds, that should pass before a channel that previously had a failed swap will be included in suggestions. (default: 0)

--fast: if set new swaps are expected to be published immediately, paying a potentially higher fee. If not set the swap server might choose to wait up to 30 minutes before publishing swap HTLCs on-chain, to save on chain fees. Not setting this flag therefore might result in a lower swap fees

--feepercent="": the maximum percentage of swap amount to be used across all fee categories (default: 0)

--help, -h: show help

--htlc_conf="": the confirmation target for loop in on-chain htlcs. (default: 0)

--localbalancesat="": the target size of total local balance in satoshis, used by easy autoloop. (default: 0)

--loopinsource="": the loop-in source to use for autoloop rules: wallet or static-address. Static-address requires loopd --experimental.

--maxamt="": the maximum amount in satoshis that the autoloop client will dispatch per-swap. (default: 0)

--maxminer="": the maximum miner fee in satoshis that swap suggestions should be limited to. (default: 0)

--maxprepay="": the maximum no-show (prepay) in satoshis that swap suggestions should be limited to. (default: 0)

--maxprepayfee="": the maximum percentage of off-chain prepay volume that we are willing to pay in routing fees. (default: 0)

--maxroutingfee="": the maximum percentage of off-chain payment volume that we are willing to pay in routingfees. (default: 0)

--maxswapfee="": the maximum percentage of swap volume we are willing to pay in server fees. (default: 0)

--minamt="": the minimum amount in satoshis that the autoloop client will dispatch per-swap. (default: 0)

--sweepconf="": the number of blocks from htlc height that swap suggestion sweeps should target, used to estimate max miner fee. (default: 0)

--sweeplimit="": the limit placed on our estimated sweep fee in sat/vByte. (default: 0)

getinfo
show general information about the loop daemon

--help, -h: show help

abandonswap
abandon a swap with a given swap hash

--help, -h: show help

--i_know_what_i_am_doing: Specify this flag if you made sure that you read and understood the following consequence of applying this command.

reservations, r
manage reservations

--help, -h: show help

  list, l
list all reservations

--help, -h: show help

instantout
perform an instant off-chain to on-chain swap (looping out)

--addr="": the optional address that the looped out funds should be sent to, if let blank the funds will go to lnd's wallet

--channel="": the comma-separated list of short channel IDs of the channels to loop out

--help, -h: show help

listinstantouts
list all instant out swaps

--help, -h: show help

stop
stop the loop daemon

--help, -h: show help

--wait: wait until loopd fully shuts down

static, s
perform on-chain to off-chain swaps using static addresses.

--help, -h: show help

  new, n
Create a new static loop in address.

--help, -h: show help

  listunspent, l
List unspent static address outputs.

--help, -h: show help

--max_confs="": The maximum number of confirmations an output could have to be listed. (default: 0)

--min_confs="": The minimum amount of confirmations an output should have to be listed. (default: 0)

  listdeposits
Displays static address deposits. A filter can be applied to only show deposits in a specific state.

--filter="": specify a filter to only display deposits in the specified state. Leaving out the filter returns all deposits. The state can be one of the following: deposited withdrawing withdrawn looping_in looped_in opening_channel channel_published publish_expired_deposit sweep_htlc_timeout htlc_timeout_swept wait_for_expiry_sweep expired failed .

--help, -h: show help

  listwithdrawals
Display a summary of past withdrawals.

--help, -h: show help

  listswaps
Shows a list of static address swaps.

--help, -h: show help

  withdraw, w
Withdraw from static address deposits.

--all: withdraws all static address deposits.

--amt, --amount="": the number of satoshis that should be withdrawn from the selected deposits. The change is sent back to the static address (default: 0)

--dest_addr="": the optional address that the withdrawn funds should be sent to, if let blank the funds will go to lnd's wallet

--help, -h: show help

--sat_per_vbyte="": (optional) a manual fee expressed in sat/vbyte that should be used when crafting the transaction (default: 0)

--utxo="": specify utxos as outpoints(tx:idx) which willbe withdrawn. (default: [])

  summary, s
Display a summary of static address related information.

--help, -h: show help

  in
Loop in funds from static address deposits.

--all: loop in all static address deposits.

--amt, --amount="": the number of satoshis that should be swapped from the selected deposits. If thereis change it is sent back to the static address. (default: 0)

--fast: Usage: complete the swap faster by paying a higher fee, so the change output is available sooner

--force: Assumes yes during confirmation. Using this option will result in an immediate swap

--help, -h: show help

--label="": an optional label for this swap,limited to 500 characters. The label may not start with our reserved prefix: [reserved].

--last_hop="": the pubkey of the last hop to use for this swap

--max_swap_fee_ppm="": the maximum swap fee expressed in parts per million of the swap amount. If set together with --max_swap_fee_sat the tighter cap is used. (default: 0)

--max_swap_fee_sat="": the maximum swap fee in satoshis. If set, the swap is rejected when the quoted fee exceeds this cap. The maximum allowed value is 10000000. On-chain fees for creating static deposits are unaffected. (default: 0)

--payment_timeout="": the maximum time in seconds that the server is allowed to take for the swap payment. The client can retry the swap with adjusted parameters after the payment timed out. (default: 0s)

--private: generates and passes routehints. Should be used if the connected node is only reachable via private channels

--route_hints="": route hints that can each be individually used to assist in reaching the invoice's destination (default: [])

--utxo="": specify the utxos of deposits as outpoints(tx:idx) that should be looped in. (default: [])

--verbose, -v: show expanded details

  openchannel
Open a channel to an existing peer.

--base_fee_msat="": the base fee in milli-satoshis that will be charged for each forwarded HTLC, regardless of payment size (default: 0)

--channel_type="": (optional) the type of channel to propose to the remote peer ("tweakless", "anchors", "simple-taproot", "taproot")

--close_address="": (optional) an address to enforce payout of our funds to on cooperative close. Note that if this value is set on channel open, you will not be able to cooperatively close to a different address.

--fee_rate_ppm="": the fee rate ppm (parts per million) that will be charged proportionally based on the value of each forwarded HTLC, the lowest possible rate is 0 with a granularity of 0.000001 (millionths) (default: 0)

--fundmax: if set, the wallet will attempt to commit the maximum possible local amount to the channel. This must not be set at the same time as local_amt

--help, -h: show help

--local_amt="": the number of satoshis the wallet should commit to the channel (default: 0)

--max_local_csv="": (optional) the maximum number of blocks that we will allow the remote peer to require we wait before accessing our funds in the case of a unilateral close. (default: 0)

--memo="": (optional) a note-to-self containing some useful information about the channel. This is stored locally only, and is purely for reference. It has no bearing on the channel's operation. Max allowed length is 500 characters

--min_htlc_msat="": (optional) the minimum value we will require for incoming HTLCs on the channel (default: 0)

--node_key="": the identity public key of the target node/peer serialized in compressed format

--private: make the channel private, such that it won't be announced to the greater network, and nodes other than the two channel endpoints must be explicitly told about it to be able to route through it

--push_amt="": the number of satoshis to give the remote side as part of the initial commitment state, this is equivalent to first opening a channel and sending the remote party funds, but done all in one step (default: 0)

--remote_csv_delay="": (optional) the number of blocks we will require our channel counterparty to wait before accessing its funds in case of unilateral close. If this is not set, we will scale the value according to the channel size (default: 0)

--remote_max_value_in_flight_msat="": (optional) the maximum value in msat that can be pending within the channel at any given time (default: 0)

--remote_reserve_sats="": (optional) the minimum number of satoshis we require the remote node to keep as a direct payment. If not specified, a default of 1% of the channel capacity will be used. (default: 0)

--sat_per_vbyte="": (optional) a manual fee expressed in sat/vbyte that should be used when crafting the transaction (default: 0)

--scid_alias: (optional) whether a scid-alias channel type should be negotiated.

--utxo="": a utxo specified as outpoint(tx:idx) which will be used to fund a channel. This flag can be repeatedly used to fund a channel with a selection of utxos. The selected funds can either be entirely spent by specifying the fundmax flag or partially by selecting a fraction of the sum of the outpoints in local_amt (default: [])

--zero_conf: (optional) whether a zero-conf channel open should be attempted.